//package org.supermind;
//
//import org.supermind.url.URLParser;
//import org.supermind.url.ParsedURL;
//
//import java.io.*;
//import java.util.Properties;
//import java.util.Map;
//import java.util.concurrent.ExecutorService;
//import java.util.concurrent.Executors;
//import java.net.MalformedURLException;
//import java.net.Socket;
//import java.net.InetAddress;
//
//public class ProxyServer extends NanoHTTPD {
//  private static final String CRLF = "\r\n";
//  private static final byte[] CONNECT_OK = ("HTTP/1.0 200 Connection established" + CRLF + "Proxy-agent: ProxyLight" + CRLF + CRLF).getBytes();
//  private ExecutorService sslThreadPool = Executors.newFixedThreadPool(3);
//
//  public static void main(String[] args) {
//    try {
//      new ProxyServer(9999);
//    }
//    catch (IOException ioe) {
//      System.err.println("Couldn't start server:\n" + ioe);
//      System.exit(-1);
//    }
//    System.out.println("Listening on port 8080. Hit Enter to stop.\n");
//    try {
//      System.in.read();
//    } catch (Throwable t) {
//    }
//    ;
//  }
//
//  public ProxyServer(int port) throws IOException {
//    super(port);
//  }
//
//  @Override protected HTTPSession createHTTPSession(Socket s) {
//    return new HTTPSession(s) {
//      @Override protected void handleRequest(String rawRequest, String method, String uri, Properties parms, Properties header) throws InterruptedException {
//        // Ok, now do the serve()
//        Response r = serve(rawRequest, uri, method, header, parms);
//        if (r == null)
//          super.sendError(HTTP_INTERNALERROR, "SERVER INTERNAL ERROR: Serve() returned a null response.");
//        else {
//          // get raw streams
//          byte[] buf = new byte[4096];
//          try {
//            OutputStream clientOut = clientSocket.getOutputStream();
//            if (method.equalsIgnoreCase("connect")) {
//              clientOut.write(CONNECT_OK);
//              clientOut.flush();
//              System.out.println("Connect OK. Waiting for more data...");
//              int socketTimeout = 10000;
////              clientSocket.setSoTimeout(socketTimeout);
////              r.serverSocket.setSoTimeout(socketTimeout);
//              OutputStream serverOut = r.serverSocket.getOutputStream();
//              InputStream clientIn = clientSocket.getInputStream();
//              Thread t = new Thread(new Copy(clientIn, serverOut));
//              t.start();
//              synchronized (this) {
//                Thread.sleep(10);
//                System.out.println("Resumed");
//              }
//              transferFlush(r.serverSocket.getInputStream(), clientOut, buf);
//              System.out.println("Closing the SSL socket");
//              clientSocket.close();
//              r.serverSocket.close();
//            } else {
//              transferFlush(r.serverIn, clientOut, buf);
//              clientOut.flush();
//              clientOut.close();
//              r.serverIn.close();
//            }
//          } catch (IOException e) {
//            e.printStackTrace();
//            super.sendError(HTTP_INTERNALERROR, "SERVER INTERNAL ERROR: IOException:" + e.getMessage());
//          }
//        }
//      }
//    };
//  }
//
//  private void readFully(InputStream in, byte[] buf) throws IOException {
//    int read;
//    while ((read = in.read(buf, 0, buf.length)) != -1) {
//      System.out.println(new String(buf, 0, read));
//    }
//  }
//
//  private int transfer(InputStream in, OutputStream out, byte[] buf) throws IOException {
//    int total = 0;
//    int read;
//    while ((read = in.read(buf, 0, buf.length)) != -1) {
//      out.write(buf, 0, read);
//      total += read;
//    }
//    return total;
//  }
//
//  private int transferFlush(InputStream in, OutputStream out, byte[] buf) throws IOException {
//    int total = 0;
//    int read;
//    while ((read = in.read(buf, 0, buf.length)) != -1) {
//      out.write(buf, 0, read);
//      out.flush();
//      total += read;
//    }
//    return total;
//  }
//
//
//  private int transferOne(InputStream in, OutputStream out, byte[] buf) throws IOException {
//    int total = 0;
//    int read;
//    if ((read = in.read(buf, 0, buf.length)) != -1) {
//      System.out.println(new String(buf, 0, read));
//      out.write(buf, 0, read);
//      total += read;
//    }
//    return total;
//  }
//
//
//  @Override public Response serve(String rawRequest, String uri, String method, Properties header, Properties parms) {
//    int port = 80;
//    String host = null;
//    if (method.equalsIgnoreCase("connect")) {
//      int idx = uri.indexOf(":");
//      if (idx > -1) {
//        host = uri.substring(0, idx);
//        port = Integer.parseInt(uri.substring(idx + 1, uri.length()));
//      } else {
//        host = uri;
//        port = 443;
//      }
//    } else {
//      if (uri.startsWith("/")) { // relative url
//        host = header.getProperty("Host");
//      } else {
//        if (!uri.startsWith("http")) uri += "http://";
//        try {
//          ParsedURL pu = URLParser.parse(uri);
//          host = pu.getHost();
//          if (pu.getPort() != null) port = Integer.parseInt(pu.getPort());
//        } catch (MalformedURLException e) {
//          host = header.getProperty("Host");
//        }
//      }
//    }
//    try {
//      System.out.println("Fetching " + host + ":" + port + "\n" + rawRequest);
//      InetAddress wwwHost = InetAddress.getByName(host);
//      Socket serverSocket = new Socket(wwwHost, port);
//      if(!method.equalsIgnoreCase("connect")) {
//        HttpConnection2.sendRequest(serverSocket, rawRequest);
//      }
//
//      Response response = new Response(HTTP_OK, MIME_HTML, serverSocket.getInputStream());
//      response.serverSocket = serverSocket;
//      return response;
//    } catch (IOException e) {
//      e.printStackTrace();
//      return null;
//    }
//  }
//}
